﻿Imports Microsoft.VisualBasic
#Region "Copyright Syncfusion Inc. 2001 - 2011"
' Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
' Use of this code is subject to the terms of our license.
' A copy of the current license can be obtained at any time by e-mailing
' licensing@syncfusion.com. Any infringement will be prosecuted under
' applicable laws. 
#End Region
Imports Syncfusion.Windows.Tools.Controls
Imports System.Windows
Imports System.IO
Imports System
Imports System.Windows.Media
Imports Syncfusion.Windows.Controls.Grid
Imports Syncfusion.Windows.Controls.Cells
Imports System.Collections.Generic
Imports System.ComponentModel
Imports Syncfusion.Windows.Controls.Spreadsheet
Imports System.Globalization
Imports System.Windows.Controls


Namespace UCSpreadsheet
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class Spreadsheet
		Inherits UserControl
		Public Sub New()
			InitializeComponent()
			AddHandler spreadSheetControl.WorkBookLoaded, AddressOf spreadSheetControl_WorkBookLoaded
			AddHandler spreadSheetControl.Loaded, AddressOf spreadSheetControl_Loaded

		End Sub

		Private Sub spreadSheetControl_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Me.spreadSheetControl.GridProperties.ActiveSpreadsheetGrid.Model.CommandStack.Enabled = True
		End Sub

		Private Sub spreadSheetControl_WorkBookLoaded(ByVal sender As Object, ByVal args As WorkbookLoadedEventArgs)
			For Each grid As SpreadsheetGrid In args.GridCollection
				AddCustomFormula(grid.Model)
			Next grid
		End Sub

		Private Sub AddCustomFormula(ByVal gridModel As GridModel)
			' Add a formula named SumPosNums to the Library.
			gridModel.FormulaEngine.AddFunction("SumPosNums", New GridFormulaEngine.LibraryFunction(AddressOf ComputeSumPosNums))
		End Sub

		' Implement Your Method.
		Public Function ComputeSumPosNums(ByVal args As String) As String
			Dim model As SpreadsheetGridModel = spreadSheetControl.GridProperties.CurrentExcelGridModel
			If model IsNot Nothing Then
				Dim engine As GridFormulaEngine = model.FormulaEngine
				Dim sum As Double = 0R
				Dim d As Double
				Dim s1 As String
				' Loop through any arguments and sum up the positive values.
				For Each r As String In args.Split(New Char() { ","c })
					' Cell range
					If r.IndexOf(":"c) > -1 Then
						For Each s As String In engine.GetCellsFromArgs(r)
							' s is a cell line a21 or c3, and so on.
							Try
								s1 = engine.GetValueFromArg(s)
							Catch ex As Exception
								Return ex.Message
							End Try
							If s1 <> "" Then
								' Add only if positive.
								If Double.TryParse(s1, NumberStyles.Number, Nothing, d) AndAlso d > 0 Then
									sum += d
								End If
							End If
						Next s
					Else
						Try
							s1 = engine.GetValueFromArg(r)
						Catch ex As Exception
							Return ex.Message
						End Try
						If s1 <> "" Then
							If Double.TryParse(s1, NumberStyles.Number, Nothing, d) AndAlso d > 0 Then
								sum += d
							End If
						End If
					End If
				Next r
				Return sum.ToString()
			End If
			Return ""
		End Function
	End Class
End Namespace
